#include <windows.h>
#include <stdio.h>
#include <malloc.h>

#include "MemoryModule.c"

#define IDR_DLL 1000

typedef BOOL (__stdcall *PTEST)();

VOID SysError()
{
	LPVOID lpMsgBuf;
	LPVOID lpDisplayBuf;
	DWORD  dwError;
	
	dwError = GetLastError();
	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL, dwError, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL );
	lpDisplayBuf = (LPVOID)LocalAlloc(LMEM_ZEROINIT, (lstrlen((LPCTSTR)lpMsgBuf)+40)*sizeof(TCHAR)); 
	wsprintf((LPTSTR)lpDisplayBuf, "Error %d: %s", dwError, lpMsgBuf); 
	MessageBox(NULL, (LPCTSTR)lpDisplayBuf, NULL, MB_OK); 
	LocalFree(lpMsgBuf);
	LocalFree(lpDisplayBuf);
	ExitProcess(0);
}

VOID CustError(LPCSTR lpError)
{
	MessageBox(NULL, lpError, NULL, MB_OK); 
	ExitProcess(0);
}
int main(int argc, char *argv)
{
	HMEMORYMODULE module;
	PTEST pTest;
	HRSRC hRSRC;
	HGLOBAL hRSRC2;
	LPVOID pDLL;
	HINSTANCE hInstance;
	
	hInstance = GetModuleHandle(NULL);
	if ((hRSRC = FindResource(hInstance, MAKEINTRESOURCE(IDR_DLL), "RT_RCDATA")) == NULL) { SysError(); }
	if ((hRSRC2 = LoadResource(hInstance, hRSRC)) == NULL) { SysError(); }
	if ((pDLL = LockResource(hRSRC2)) == NULL) { SysError(); }
	
	if ((module = MemoryLoadLibrary(pDLL)) == NULL) { CustError("Error loading library"); }
	pTest = (PTEST)MemoryGetProcAddress(module, "TestFunc@0");
	pTest();
	
	MemoryFreeLibrary(module);
	ExitProcess(0);
}

